﻿#!/usr/bin/env python
# -*- Python -*-

import sys
import time
sys.path.append(".")

# Import RTM module
import OpenRTM_aist
import RTC

import codecs

import pygame
from pygame.locals import *


# Import Service implementation class
# <rtc-template block="service_impl">

# </rtc-template>

# Import Service stub modules
# <rtc-template block="consumer_import">
# </rtc-template>


# This module's spesification
# <rtc-template block="module_spec">
Controller_spec = ["implementation_id", "Controller", 
		 "type_name",         "Controller", 
		 "description",       "Controller Component", 
		 "version",           "0.1", 
		 "vendor",            "Miyamoto Nobuhiko", 
		 "category",          "TEST", 
		 "activity_type",     "DataFlowComponent", 
		 "max_instance",      "1", 
		 "language",          "Python", 
		 "lang_type",         "SCRIPT",
		 ""]
# </rtc-template>

class Controller(OpenRTM_aist.DataFlowComponentBase):
	def __init__(self, manager):
                
		OpenRTM_aist.DataFlowComponentBase.__init__(self, manager)

		self._d_ball = RTC.TimedDoubleSeq(RTC.Time(0,0),[])
		self._ballOut = OpenRTM_aist.OutPort("ball", self._d_ball, OpenRTM_aist.RingBuffer(8))
		self._d_button = RTC.TimedLongSeq(RTC.Time(0,0),[])
		self._buttonOut = OpenRTM_aist.OutPort("button", self._d_button, OpenRTM_aist.RingBuffer(8))
		self._d_axis = RTC.TimedLongSeq(RTC.Time(0,0),[])
		self._axisOut = OpenRTM_aist.OutPort("axis", self._d_axis, OpenRTM_aist.RingBuffer(8))
		self._d_hat = RTC.TimedDoubleSeq(RTC.Time(0,0),[])
		self._hatOut = OpenRTM_aist.OutPort("hat", self._d_hat, OpenRTM_aist.RingBuffer(8))

		
		# Set OutPort buffers
		self.registerOutPort("boll",self._ballOut)
		self.registerOutPort("button",self._buttonOut)
		self.registerOutPort("axis",self._axisOut)
		self.registerOutPort("hat",self._hatOut)




		
		

		self.joy = Joystick(0)


		

		

		

		
		# Set service provider to Ports
		
		# Set service consumers to Ports
		
		# Set CORBA Service Ports
		

		# initialize of configuration-data.
		# <rtc-template block="init_conf_param">
		
		# </rtc-template>


		 
	def onInitialize(self):
            
		# Bind variables and configuration variable
		
		return RTC.RTC_OK


	
	#def onFinalize(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onStartup(self, ec_id):
	#
	#	return RTC.RTC_OKvdef onShutdown(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	def onActivated(self, ec_id):
		SCREEN_SIZE = (640, 480)
		pygame.init()
                #screen = pygame.display.set_mode(SCREEN_SIZE)
                #pygame.display.set_caption("Controller")
	
                return RTC.RTC_OK
	
	#def onDeactivated(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	def onExecute(self, ec_id):

            self._d_ball.data = self.joy.get_ball()
            self._d_button.data = self.joy.get_button()
            self._d_axis.data = self.joy.get_axis()
            self._d_hat.data = self.joy.get_hat()
            self._ballOut.write()
            self._buttonOut.write()
            self._axisOut.write()
            self._hatOut.write()
            
            for event in pygame.event.get():
                if event.type == QUIT:
                    sys.exit()
                if event.type == KEYDOWN and event.key == K_ESCAPE:
                    sys.exit()
            
            
            
	    return RTC.RTC_OK
	
	#def onAborting(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onError(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onReset(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onStateUpdate(self, ec_id):
	#
	#	return RTC.RTC_OK
	
	#def onRateChanged(self, ec_id):
	#
	#	return RTC.RTC_OK
	

class Joystick:
    """ジョイスティックを簡単に使うためのクラス

    宣言後にスティック本数調べて、付いてるかどうか
    調べてから、ボタン類をコールしないと落ちます。"""
    accuracy = 4 # アナログ入力の値精度
    def __init__(self, id=0, mode=0):
        """Joystickの存在数と初期化チェック

        id:使用するスティックのID
        mode:使用するモード。デジタルなら0、アナログなら1"""
        joystick = pygame.joystick # short name
        joystick.init()
        if not joystick.get_init():
            # 初期化に失敗したらメッセージ表示
            print "Initialize error: Joystick"
            self.sticknum = 0
        else:
            self.sticknum = joystick.get_count()
            self._setup(id)
        self._mode = mode

    def ChangeStick(id):
        """使用パッドを切り替える"""
        if id < self.sticknum:
            return self._setup(id)
        else:
            return False

    def _setup(self, id):
        try:
            self.stick = pygame.joystick.Joystick(id)
        except pygame.error, message:
            print "Joystick ID Error: %d"%id
            raise SystemExit, message
        self.stick.init()
        return self.stick.get_init()



    def get_button(self):
        """ボタン入力をタプルで返す"""
        inputs = []
        if self.stick.get_numbuttons() > 0:
            for i in range(self.stick.get_numbuttons()):
                inputs.append(self.stick.get_button(i))
            return tuple(inputs)
        else:
            return []

    def get_ball(self):
        inputs = []
        if self.stick.get_numballs() > 0:
            for i in range(self.stick.get_numballs):
                inputs.append(self.stick.get_ball(i))
            return tuple(inputs)
        else:
            return []

    def get_axis(self):
        """アナログキー入力をタプルで返す"""
        inputs = []
        if not self._mode == 0:
            # アナログモードならそのまま
            for i in range(self.stick.get_numaxes()):
                axis = round(self.stick.get_axis(i), self.accuracy)
                inputs.append(axis)
            return tuple(inputs)
        else:
            # デジタルモードなら方向キーに変換
            hat = []
            for i in range(self.stick.get_numaxes()):
                if i < 2: # 最初に見つかったもののみ使う
                    axis = round(self.stick.get_axis(i), self.accuracy)
                    if i == 1: # 2つ目の縦軸入力は上下反転
                        hat.append(-axis)
                    else:
                        hat.append(axis)
            inputs = self._get_arrow(hat)
            return tuple(inputs)

    def get_hat(self):
        """デジタル方向キーをタプルで返す

        hatは複数あるかもしれないけど、一般的な
        ゲームパッドでは1つなので1つだけ処理する。"""
        if self.stick.get_numhats() > 0:

            inputs = self._get_arrow(self.stick.get_hat(0))
            return tuple(inputs)
        else:
            return []

    def _get_arrow(self, inputpos):
        """方向キー(x,y)のセットを4つに分ける"""
        inputs = []
        for h in inputpos:
            if h < 0:
                inputs.append(1)
                inputs.append(0)
            elif h > 0:
                inputs.append(0)
                inputs.append(1)
            else:
                inputs.append(0)
                inputs.append(0)
        return inputs



def MyModuleInit(manager):
    profile = OpenRTM_aist.Properties(defaults_str=Controller_spec)
    manager.registerFactory(profile,
                            Controller,
                            OpenRTM_aist.Delete)

    # Create a component
    comp = manager.createComponent("Controller")



def main():
	mgr = OpenRTM_aist.Manager.init(len(sys.argv), sys.argv)
	mgr.setModuleInitProc(MyModuleInit)
	mgr.activateManager()
	mgr.runManager()

if __name__ == "__main__":
	main()

